diff --git a/modules/systemd-journal/journal-reader.c b/modules/systemd-journal/journal-reader.c
index 56eefe1410..ffaad19abc 100644
--- a/modules/systemd-journal/journal-reader.c
+++ b/modules/systemd-journal/journal-reader.c
@@ -350,25 +350,72 @@ _skip_old_records(JournalReader *self)
   return TRUE;
 }
 
-static inline gboolean
-_seek_to_saved_state(JournalReader *self)
+static gboolean
+_journal_seek(Journald *journal, const gchar *cursor)
 {
-  JournalReaderState *state = persist_state_map_entry(self->persist_state, self->persist_handle);
-  gint rc = journald_seek_cursor(self->journal, state->cursor);
-  persist_state_unmap_entry(self->persist_state, self->persist_handle);
+  gint rc = journald_seek_cursor(journal, cursor);
+
   if (rc != 0)
     {
       msg_warning("Failed to seek journal to the saved cursor position",
-                  evt_tag_str("cursor", state->cursor),
+                  evt_tag_str("cursor", cursor),
                   evt_tag_errno("error", -rc));
-      return _seek_to_head(self);
+      return FALSE;
     }
-  else
+
+  return TRUE;
+}
+
+static gboolean
+_journal_next(Journald *journal)
+{
+  gint rc = journald_next(journal);
+
+  if (rc != 1)
+    {
+      msg_warning("Failed to step cursor",
+                  evt_tag_errno("error", -rc));
+      return FALSE;
+    }
+
+  return TRUE;
+}
+
+static gboolean
+_journal_test_cursor(Journald *journal, const gchar *cursor)
+{
+  gint rc = journald_test_cursor(journal, cursor);
+
+  if (rc <= 0)
     {
-      msg_debug("Seeking the journal to the last cursor position",
-                evt_tag_str("cursor", state->cursor));
+      msg_warning("Current position not matches to the saved cursor position, seek to head",
+                  evt_tag_str("cursor", cursor),
+                  evt_tag_errno("error", -rc));
+      return FALSE;
     }
-  journald_next(self->journal);
+
+  return TRUE;
+}
+
+static inline gboolean
+_seek_to_saved_state(JournalReader *self)
+{
+  JournalReaderState *state = persist_state_map_entry(self->persist_state, self->persist_handle);
+
+  if (!_journal_seek(self->journal, state->cursor) ||
+      !_journal_next(self->journal) ||
+      !_journal_test_cursor(self->journal, state->cursor))
+    {
+      persist_state_unmap_entry(self->persist_state, self->persist_handle);
+
+      return _seek_to_head(self);
+    }
+
+  msg_debug("Seeking the journal to the last cursor position",
+            evt_tag_str("cursor", state->cursor));
+
+  persist_state_unmap_entry(self->persist_state, self->persist_handle);
+
   return TRUE;
 }
 
diff --git a/modules/systemd-journal/journald-subsystem.c b/modules/systemd-journal/journald-subsystem.c
index e4e620b610..d9bc0c2a6d 100644
--- a/modules/systemd-journal/journald-subsystem.c
+++ b/modules/systemd-journal/journald-subsystem.c
@@ -76,6 +76,8 @@ typedef int
 typedef int
 (*SD_JOURNAL_SEEK_CURSOR)(sd_journal *j, const char *cursor);
 typedef int
+(*SD_JOURNAL_TEST_CURSOR)(sd_journal *j, const char *cursor);
+typedef int
 (*SD_JOURNAL_GET_FD)(sd_journal *j);
 typedef int
 (*SD_JOURNAL_PROCESS)(sd_journal *j);
@@ -91,6 +93,7 @@ static SD_JOURNAL_NEXT sd_journal_next;
 static SD_JOURNAL_RESTART_DATA sd_journal_restart_data;
 static SD_JOURNAL_ENUMERATE_DATA sd_journal_enumerate_data;
 static SD_JOURNAL_SEEK_CURSOR sd_journal_seek_cursor;
+static SD_JOURNAL_TEST_CURSOR sd_journal_test_cursor;
 static SD_JOURNAL_GET_FD sd_journal_get_fd;
 static SD_JOURNAL_PROCESS sd_journal_process;
 static SD_JOURNAL_GET_REALTIME_USEC sd_journal_get_realtime_usec;
@@ -143,6 +146,9 @@ _load_journald_symbols(void)
   if (!LOAD_SYMBOL(journald_module, sd_journal_get_realtime_usec))
     return FALSE;
 
+  if (!LOAD_SYMBOL(journald_module, sd_journal_test_cursor))
+    return FALSE;
+
   return TRUE;
 }
 
@@ -224,6 +230,12 @@ journald_seek_cursor(Journald *self, const gchar *cursor)
   return sd_journal_seek_cursor(self->journal, cursor);
 }
 
+int
+journald_test_cursor(Journald *self, const gchar *cursor)
+{
+  return sd_journal_test_cursor(self->journal, cursor);
+}
+
 int
 journald_get_fd(Journald *self)
 {
diff --git a/modules/systemd-journal/journald-subsystem.h b/modules/systemd-journal/journald-subsystem.h
index de127c3a29..eb5bff0e56 100644
--- a/modules/systemd-journal/journald-subsystem.h
+++ b/modules/systemd-journal/journald-subsystem.h
@@ -61,6 +61,7 @@ int journald_next(Journald *self);
 void journald_restart_data(Journald *self);
 int journald_enumerate_data(Journald *self, const void **data, gsize *length);
 int journald_seek_cursor(Journald *self, const gchar *cursor);
+int journald_test_cursor(Journald *self, const gchar *cursor);
 int journald_get_fd(Journald *self);
 int journald_process(Journald *self);
 int journald_get_realtime_usec(Journald *self, guint64 *usec);
diff --git a/modules/systemd-journal/tests/journald-mock.c b/modules/systemd-journal/tests/journald-mock.c
index f0049e8c7b..1e2fe9044c 100644
--- a/modules/systemd-journal/tests/journald-mock.c
+++ b/modules/systemd-journal/tests/journald-mock.c
@@ -147,6 +147,12 @@ journald_seek_cursor(Journald *self, const gchar *cursor)
     }
 }
 
+int
+journald_test_cursor(Journald *self, const gchar *cursor)
+{
+  return 1;
+}
+
 int
 journald_get_fd(Journald *self)
 {
